diff --git a/include/gpac/internal/isomedia_dev.h b/include/gpac/internal/isomedia_dev.h
index 1cfea922be..b6cf5b1ea0 100644
--- a/include/gpac/internal/isomedia_dev.h
+++ b/include/gpac/internal/isomedia_dev.h
@@ -714,8 +714,7 @@ typedef struct
 	u32 originalID;
 
 	//not sure about piff (not supposed to be stored in moov), but senc is in track according to CENC
-	GF_Box *piff_psec;
-	GF_Box *senc;
+	struct __sample_encryption_box *sample_encryption;
 
 	/*private for SVC/MVC extractors resolution*/
 	s32 extractor_mode;
@@ -1445,8 +1444,6 @@ typedef struct
 	u16 trackPriority;
 	u32 currentEntryIndex;
 
-	//stored in other boxes, no need to delete it
-	struct __sample_encryption_box *senc;
 	Bool no_sync_found;
 } GF_SampleTableBox;
 
diff --git a/src/isomedia/box_code_base.c b/src/isomedia/box_code_base.c
index 2e030e4147..dfffd6296e 100644
--- a/src/isomedia/box_code_base.c
+++ b/src/isomedia/box_code_base.c
@@ -6989,14 +6989,11 @@ GF_Err trak_AddBox(GF_Box *s, GF_Box *a)
 		ptr->groups = (GF_TrackGroupBox *)a;
 		return GF_OK;
 	case GF_ISOM_BOX_TYPE_SENC:
-		ptr->senc = a;
-		return gf_isom_box_add_default((GF_Box *)ptr, a);
-	case GF_ISOM_BOX_UUID_PSEC:
-		ptr->piff_psec = a;
+		ptr->sample_encryption = (GF_SampleEncryptionBox*)a;
 		return gf_isom_box_add_default((GF_Box *)ptr, a);
 	case GF_ISOM_BOX_TYPE_UUID:
 		if (((GF_UnknownUUIDBox *)a)->internal_4cc == GF_ISOM_BOX_UUID_PSEC) {
-			ptr->piff_psec = a;
+			ptr->sample_encryption = (GF_SampleEncryptionBox*) a;
 			return gf_isom_box_add_default((GF_Box *)ptr, a);
 		}
 
@@ -7026,13 +7023,9 @@ GF_Err trak_Read(GF_Box *s, GF_BitStream *bs)
 
 	//we should only parse senc/psec when no saiz/saio is present, otherwise we fetch the info directly
 	if (ptr->Media && ptr->Media->information && ptr->Media->information->sampleTable /*&& !ptr->Media->information->sampleTable->sai_sizes*/) {
-		if (ptr->senc) {
-			e = senc_Parse(bs, ptr, NULL, (GF_SampleEncryptionBox *)ptr->senc);
-		}
-		else if (ptr->piff_psec) {
-			e = senc_Parse(bs, ptr, NULL, (GF_SampleEncryptionBox *) ptr->piff_psec);
+		if (ptr->sample_encryption) {
+			e = senc_Parse(bs, ptr, NULL, ptr->sample_encryption);
 		}
-
 	}
 	return e;
 }
diff --git a/src/isomedia/drm_sample.c b/src/isomedia/drm_sample.c
index bdaaf0e233..c666fa83b2 100644
--- a/src/isomedia/drm_sample.c
+++ b/src/isomedia/drm_sample.c
@@ -554,7 +554,7 @@ Bool gf_isom_is_cenc_media(GF_ISOFile *the_file, u32 trackNumber, u32 sampleDesc
 	trak = gf_isom_get_track_from_file(the_file, trackNumber);
 	if (!trak) return GF_FALSE;
 
-	if (trak->Media->information->sampleTable->senc) return GF_TRUE;
+	if (trak->sample_encryption) return GF_TRUE;
 
 	sinf = isom_get_sinf_entry(trak, sampleDescriptionIndex, GF_ISOM_CENC_SCHEME, NULL);
 	if (!sinf) sinf = isom_get_sinf_entry(trak, sampleDescriptionIndex, GF_ISOM_CBC_SCHEME, NULL);
@@ -875,20 +875,19 @@ GF_Err gf_isom_cenc_allocate_storage(GF_ISOFile *the_file, u32 trackNumber, u32
 	GF_TrackBox *trak = gf_isom_get_track_from_file(the_file, trackNumber);
 	if (!trak) return GF_BAD_PARAM;
 
+	if (trak->sample_encryption) return GF_OK;
 	switch (container_type) {
 	case GF_ISOM_BOX_UUID_PSEC:
-		if (trak->piff_psec) return GF_OK;
-		trak->piff_psec = (GF_Box *)gf_isom_create_piff_psec_box(1, 0, AlgorithmID, IV_size, KID);
-		//senc will be written and destroyed with the other boxes
-		return gf_isom_box_add_default((GF_Box *) trak, trak->piff_psec);
-
+		trak->sample_encryption = (GF_SampleEncryptionBox *)gf_isom_create_piff_psec_box(1, 0, AlgorithmID, IV_size, KID);
+		break;
 	case GF_ISOM_BOX_TYPE_SENC:
-		if (trak->senc) return GF_OK;
-		trak->senc = (GF_Box *)gf_isom_create_samp_enc_box(0, 0);
-		//senc will be written and destroyed with the other boxes
-		return gf_isom_box_add_default((GF_Box *) trak, trak->senc);
+		trak->sample_encryption = (GF_SampleEncryptionBox *)gf_isom_create_samp_enc_box(0, 0);
+		break;
+	default:
+		return GF_NOT_SUPPORTED;
 	}
-	return GF_NOT_SUPPORTED;
+	//senc will be written and destroyed with the other boxes
+	return gf_isom_box_add_default((GF_Box *) trak, (GF_Box *) trak->sample_encryption);
 }
 
 #ifndef GPAC_DISABLE_ISOM_FRAGMENTS
@@ -993,10 +992,8 @@ GF_Err gf_isom_track_cenc_add_sample_info(GF_ISOFile *the_file, u32 trackNumber,
 
 	switch (container_type) {
 	case GF_ISOM_BOX_UUID_PSEC:
-		senc = (GF_SampleEncryptionBox *) trak->piff_psec;
-		break;
 	case GF_ISOM_BOX_TYPE_SENC:
-		senc = (GF_SampleEncryptionBox *) trak->senc;
+		senc = trak->sample_encryption;
 		break;
 	default:
 		return GF_NOT_SUPPORTED;
@@ -1168,7 +1165,7 @@ GF_Err gf_isom_cenc_get_sample_aux_info(GF_ISOFile *the_file, u32 trackNumber, u
 	if (!stbl)
 		return GF_BAD_PARAM;
 
-	senc = trak->Media->information->sampleTable->senc;
+	senc = trak->sample_encryption;
 	if (!senc)
 		return GF_BAD_PARAM;
 
diff --git a/src/isomedia/isom_read.c b/src/isomedia/isom_read.c
index 0f6c35bbf6..bdb3a3e7a1 100644
--- a/src/isomedia/isom_read.c
+++ b/src/isomedia/isom_read.c
@@ -4036,7 +4036,7 @@ GF_Err gf_isom_get_sample_cenc_info_ex(GF_TrackBox *trak, void *traf, GF_SampleE
 exit:
 
 	//in PIFF we may have default values if no TENC is present: 8 bytes for IV size
-	if ((senc->is_piff || trak->moov->mov->is_smooth) && !(*IV_size) ) {
+	if ((senc->is_piff || (trak->moov && trak->moov->mov->is_smooth) ) && !(*IV_size) ) {
 		if (!senc->is_piff) {
 			senc->is_piff = GF_TRUE;
 			senc->IV_size=8;
@@ -4054,7 +4054,7 @@ GF_Err gf_isom_get_sample_cenc_info(GF_ISOFile *movie, u32 track, u32 sample_num
 									u8 *crypt_byte_block, u8 *skip_byte_block, u8 *constant_IV_size, bin128 *constant_IV)
 {
 	GF_TrackBox *trak = gf_isom_get_track_from_file(movie, track);
-	GF_SampleEncryptionBox *senc = trak->Media->information->sampleTable->senc;
+	GF_SampleEncryptionBox *senc = trak->sample_encryption;
 
 	return gf_isom_get_sample_cenc_info_ex(trak, NULL, senc, sample_number, IsEncrypted, IV_size, KID, crypt_byte_block, skip_byte_block, constant_IV_size, constant_IV);
 }
diff --git a/src/isomedia/movie_fragments.c b/src/isomedia/movie_fragments.c
index ae488c72ae..42d478f8ca 100644
--- a/src/isomedia/movie_fragments.c
+++ b/src/isomedia/movie_fragments.c
@@ -1860,7 +1860,7 @@ GF_Err gf_isom_fragment_add_sai(GF_ISOFile *output, GF_ISOFile *input, u32 Track
 		case GF_ISOM_BOX_UUID_PSEC:
 			//have we seen cases where the psec box is in trak but not in traf ? to check
 			if (!traf->sample_encryption) {
-				GF_SampleEncryptionBox *psec = (GF_SampleEncryptionBox *) src_trak->piff_psec;
+				GF_SampleEncryptionBox *psec = (GF_SampleEncryptionBox *) src_trak->sample_encryption;
 				if (!psec) return GF_ISOM_INVALID_FILE;
 				traf->sample_encryption = gf_isom_create_piff_psec_box(1, 0, psec->AlgorithmID, psec->IV_size, psec->KID);
 				if (!traf->sample_encryption)
diff --git a/src/isomedia/track.c b/src/isomedia/track.c
index 7c4bf8e81a..1bfe584714 100644
--- a/src/isomedia/track.c
+++ b/src/isomedia/track.c
@@ -672,10 +672,10 @@ GF_Err MergeTrack(GF_TrackBox *trak, GF_TrackFragmentBox *traf, u64 moof_offset,
 
 				if (!trak->Media->information->sampleTable->other_boxes) trak->Media->information->sampleTable->other_boxes = gf_list_new();
 
-				assert(trak->Media->information->sampleTable->senc == NULL);
+				assert(trak->sample_encryption == NULL);
 
-				gf_list_add(trak->Media->information->sampleTable->other_boxes, senc);
-				trak->Media->information->sampleTable->senc = senc;
+				trak->sample_encryption = senc;
+				gf_isom_box_add_default((GF_Box *)trak, (GF_Box *)senc);
 			}
 
 			sais = traf->sample_encryption->samp_aux_info;
